//2010.06.30
//指定したディレクトリ内にあるMFCCテキストファイル
//（HTK付属のHCopyでMFCC解析を行った後、HListでテキストに変換した .txt 形式のファイル） を読み込んで
//1行1フレームの .csv 形式に変換する
//
// 宮澤 幸希（早稲田大学人間科学学術院 菊池英明研究室）
//
//【修正点】
// 2010.06.30 出力ファイル2列目のフレーム開始時間を修正

import java.io.*;

public class ConvertHcopyCsv {
	public static void main(String[] args) {
		String txtDirname = args[0];		//MFCC形式テキストファイルの格納場所
		String outputDirname = args[1];	//変換後のテキストファイルの出力場所
		//String txtDirname = "C:\\Users\\miyazawa\\Desktop\\data";
		//String outputDirname = "C:\\Users\\miyazawa\\Desktop\\data";

		try {
			//ファイル名取得
			File dir = new File(txtDirname);
			File[] files = dir.listFiles();
            
			//順番に処理
			String[] fnames = new String[files.length];
			for (int i = 0; i < files.length; i++) {
				fnames[i] = files[i].getName();
				if ( fnames[i].indexOf(".txt") != -1) {
					String filepath = txtDirname + "/" + fnames[i];
					System.out.println(filepath);
					
					//出力するファイル名
					String[] splFileName = fnames[i].split("\\.");
					String filePath = outputDirname + "/" + splFileName[0] + ".csv";
					
		            //初期化
					writeFile(filePath, "", true);
		            
					//指定された mfc テキストファイルを読み込んで 1 行のベクトルデータに変換する
					double sampleRate = 0;
					BufferedReader br = new BufferedReader( new FileReader (filepath) );
					String line;
					int countFileLine = 0;
					int frameNum = 0;
					String outputLine = "";
					boolean dataStart = false;
					int dataStartLine = 0;
					while((line = br.readLine()) != null) {
						if ( line.indexOf("Sample Period:") != -1) {
							//サンプリング周波数を得る
							String[] spl1 = line.split("Sample Period: ");
							String[] spl2 = spl1[1].split(" us");
							sampleRate = Double.parseDouble(spl2[0]) / 1000000;
						}
						if ((dataStart == true)&&(line.indexOf("END") == -1)) {		//行頭と行末のラベルは対象外
							//System.out.println($line);
							if (line.indexOf(":") != -1){		//データの頭行のとき（改行を加える）
								//前のデータを書き込む
								if (countFileLine > dataStartLine) {	//データの１行目でないとき
									//不特定数のスペースによる区切りを、カンマによる区切りに変換する
									outputLine = changeSpaceCsv(outputLine);
									//フレーム番号と時間を付加する
									outputLine = (frameNum + 1) + "," + ( frameNum * sampleRate ) + "," + outputLine;
									//書き込み
									//System.out.println(outputLine);
									writeFile(filePath, outputLine, false);
									//outputLine初期化
									outputLine = "";
								}
								String[] spl = line.split(":");
								frameNum = Integer.parseInt(spl[0]);
								outputLine = spl[1];
							} else {							//データの頭行以外のとき（そのまま後ろに加える）
								outputLine = outputLine + " " + line;
							}					
						}
						if ( line.indexOf("Samples: 0->-1") != -1) {
							//次の行からデータの本体開始
							dataStart = true;
							dataStartLine = countFileLine + 1;
						}
						countFileLine++;
					}
					br.close();	
				}
			}
		} catch (Exception e) {
			System.out.println(e);
		}
	}
	//ファイル出力
	public static void writeFile(String filePath, String data, boolean initCheck) {
		try {
		    if (initCheck == false) {
		    	//追加
		    	//System.out.println(filePath + "\t" + data);
			    OutputStreamWriter out = new OutputStreamWriter( new FileOutputStream(filePath, true) , "UTF-8");
			    out.write(data + "\n");
			    out.close();
		    } else {
		    	//新規
		    	//System.out.println(filePath + "\t" + data);
			    OutputStreamWriter out = new OutputStreamWriter( new FileOutputStream(filePath) , "UTF-8");
			    out.write("");
			    out.close();
		    }
		    
		} catch (Exception e) {
			System.err.println(e);
		}
	}
	// 不特定数のスペースによる区切りを、カンマによる区切りに変換する
	public static String changeSpaceCsv(String line) {
		String outputLine = "";
		String[] spl = line.split(" ");
		for (int i = 0; i < spl.length; i++) {
			if (spl[i].indexOf(".") != -1) {	//数字のデータだったら
				outputLine = outputLine + spl[i] + ",";
			}
		}
		return outputLine;
	}
}
